﻿@using BeamAndGo.Member.Admin.Web
@using Microsoft.AspNetCore.Http;
@{
    var route = (Context.Request.Path.Value).ToLower();
    var sectionClass = "";

    string[] explicitRoutes = { };
    if (!explicitRoutes.Contains(route)) sectionClass = "uk-section uk-section-xsmall";

    string sessionMemberSid = Context.Session.GetString(SessionKey.MemberSid);
    string defaultNotification = Context.Session.GetString(SessionKey.NotificationMessage.Default);
    string successNotification = Context.Session.GetString(SessionKey.NotificationMessage.Sucess);
    string errorNotification = Context.Session.GetString(SessionKey.NotificationMessage.Error);

    Context.Session.Remove(SessionKey.NotificationMessage.Default);
    Context.Session.Remove(SessionKey.NotificationMessage.Sucess);
    Context.Session.Remove(SessionKey.NotificationMessage.Error);
}
<!DOCTYPE html>
<html>
<head>
    <title>@ViewData["Title"] - Beam&Go Member</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="theme-color" content="#F15738">

    <!--Open Graph-->
    <meta property="og:url" content="https://@Context.Request.Host/" />
    <meta property="og:type" content="website" />
    <meta property="og:title" content="Member Admin" />
    <meta property="og:description" content="Beam&Go Member Admin" />
    <meta property="og:image" content="/img/app-logo/bng-branding-logo-white-001-242x64.png" />
    <meta application-name="Beam&Go Member Admin" data-member="@sessionMemberSid" />

    <!--iOS-->
    <meta name="apple-mobile-web-app-capable" content="yes" />
    <link rel="apple-touch-icon" sizes="256x256" href="/img/app-logo/bng-app-logo-orange-002-512x512.png" />

    <!--CSS-->
    <link rel="stylesheet" href="@Context.Items["StaticAssetsUrl"]/css/site.min.css" />
    <link rel="stylesheet" href="@Context.Items["StaticAssetsUrl"]/css/intl-tel-input/_intlTelInput.min.css" />
    <link rel="stylesheet" href="@Context.Items["StaticAssetsUrl"]/css/country-picker-flags/_countrySelect.min.css" />
    <link rel="stylesheet" href="/css/site.css" />

    <!--JS-->
    <script src="https://cdn.jsdelivr.net/npm/uikit@3.4.0/dist/js/uikit.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/uikit@3.4.0/dist/js/uikit-icons.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.0/dist/jquery.min.js"></script>
    <script src="https://kit.fontawesome.com/610ca81c96.js"></script>
    <script src="@Context.Items["StaticAssetsUrl"]/js/intl-tel-input/intlTelInput.min.js"></script>
    <script src="@Context.Items["StaticAssetsUrl"]/js/country-picker-flags/countrySelect.min.js"></script>
    <!--<script src="/js/qrcode.js"></script> -->
    <!--PWA-->
    @*<link href="/manifest.json" rel="manifest" />*@

    @await RenderSectionAsync("Styles", required: false)
</head>
<body>
    <header>
        @{
            if (Context.Items.ContainsKey(ItemKey.Member.Profile))
            {
                await Html.RenderPartialAsync("_HeaderMember");
                await Html.RenderPartialAsync("_SideMenu");
            }
            else
            {
                await Html.RenderPartialAsync("_HeaderNoLogin");
                await Html.RenderPartialAsync("_SideMenu");
            }
        }
    </header>
    <section class="@sectionClass" uk-height-viewport="expand: true">
        @RenderBody()
    </section>
    <footer>
        @{
            //await Html.RenderPartialAsync("_BottomNavigation");
            await Html.RenderPartialAsync("_Footer");


        }
    </footer>

    <!--Empty Modal-->
    <div id="bng-modal" uk-modal style="overflow-y:inherit !important;">
        <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">
            <button class="uk-modal-close-default" type="button" uk-close></button>
            <div id="bng-modal-body"></div>
        </div>
    </div>


    <div id="loader" style="display: none;">
        <div class="uk-overlay uk-position-cover" style="z-index: 9998;"></div>
        <div class="uk-card uk-card-default uk-card-small uk-card-body uk-position-center uk-position-fixed" style="z-index: 9999; height: 85px; width: 85px">
            <span uk-spinner="ratio: 1.5" style="height: 50px; width: 50px;"></span>
        </div>
    </div>
    <script>
        let deferredPrompt;

        //Show loading animation
        $('a').click(function () {
            let href = $(this).attr('href');
            if (href) {
                if (href.startsWith("/") && !$(this).hasClass('bng-modal')) {
                    $('#loader').show();
                } else if (!href.startsWith("#")) {
                    $('#loader').show();
                    setTimeout(function () { $('#loader').hide(); }, 500);
                }
            }

        });

        $('body').on('submit', 'form', function () {
            if ($(this).valid() === true) {
                $('#loader').show();
                setTimeout(function () { $('#loader').hide(); }, 250);
            }
        });

        //Show page as a Modal
        $('a.bng-modal').click(function (event) {
            event.preventDefault();
            modalForm($(this).attr('href'));
        });

        function modalForm(url) {
            $('#loader').show();
            $.get(url, (data, status) => {
                if (status == 'success') {
                    $('#bng-modal-body').html(data);
                    UIkit.modal($('#bng-modal')).show();
                }
                $('#loader').hide();
            });
        }

        //OnLoad event
        window.onload = () => {
            // Checks if we display install popup notification for iOS:
            if (isIos() && !isInStandaloneMode()) {
                //showInstallPromotion();
            }

            defaultNotification('@defaultNotification');
            successNotification('@successNotification');
            errorNotification('@errorNotification');
        }

        //Register Service Workers (PWA)
        //if ('serviceWorker' in navigator) {
        //    navigator.serviceWorker.register('/service-worker.js');
        //}

        //Listen for the beforeinstallprompt event
        window.addEventListener('beforeinstallprompt', (e) => {
            // Prevent the mini-infobar from appearing on mobile
            e.preventDefault();
            // Stash the event so it can be triggered later.
            deferredPrompt = e;
            // Update UI notify the user they can install the PWA
            showInstallPromotion();
            // Optionally, send analytics event that PWA install promo was shown.
            console.log(`'beforeinstallprompt' event was fired.`);
        });

        //Detect when the PWA was successfully installed
        window.addEventListener('appinstalled', () => {
            // Hide the app-provided install promotion
            hideInstallPromotion();
            // Clear the deferredPrompt so it can be garbage collected
            deferredPrompt = null;
            // Optionally, send analytics event to indicate successful install
            console.log('PWA was installed');
        });

        function hideInstallPromotion() {
            $('#installApp').hide()
        }

        function showInstallPromotion() {
            $('#installApp').show()
        }

        //In-app installation flow
        async function showPWAPrompt() {
            if (isIos() && !isInStandaloneMode()) {
                // Hide the app provided install promotion
                hideInstallPromotion();
                UIkit.modal($('#modal-pwaios')).show();
                showInstallPromotion();
            }
            else {
                // Hide the app provided install promotion
                hideInstallPromotion();
                // Show the install prompt
                deferredPrompt.prompt();
                // Wait for the user to respond to the prompt
                const { outcome } = await deferredPrompt.userChoice;
                // Optionally, send analytics event with outcome of user choice
                console.log(`User response to the install prompt: ${outcome}`);
                // We've used the prompt, and can't use it again, throw it away
                deferredPrompt = null;
            }
        }

        // Detects if device is on iOS
        function isIos() {
            const userAgent = window.navigator.userAgent.toLowerCase();
            return /iphone|ipad|ipod/.test(userAgent);
        }
        // Detects if device is in standalone mode
        function isInStandaloneMode() {
            return ('standalone' in window.navigator) && (window.navigator.standalone)
        };

        //Checking if offline
        window.addEventListener("offline", () => {
            UIkit.notification.closeAll()
            UIkit.notification({
                message: '<p class="uk-text-small uk-margin-remove"><span uk-icon="icon: rss"></span> You\'re offline</p>',
                status: 'danger',
                pos: 'bottom-right',
                timeout: 15000
            });
        });

        //Checking if online
        window.addEventListener("online", () => {
            UIkit.notification.closeAll()
            UIkit.notification({
                message: '<p class="uk-text-small uk-margin-remove"><span uk-icon="icon: rss"></span> You\'re online</p>',
                status: 'success',
                pos: 'bottom-right',
                timeout: 1500
            });
        });

        //Web Share API
        function openShareWallet(accountSid, transferUrl){
            if (navigator.share) {
                navigator.share({
                    title: 'Beam&Go Wallet',
                    text: "Transfer to my Beam&Go Wallet at",
                    url: transferUrl,
                })
                    .then(() => { console.log('Share Successfully'); })
                    .catch((error) => console.log('Error sharing', error));
            }
            else {
                UIkit.modal('#modal-share-' + accountSid).show();
            }
        }

        // Download QR Image file
        // filename = name of the file
        // data = need to generate qr image
        function downloadQR(filename, data) {
            const div = document.createElement('div');
            new QRCode(div, data);
            const src = div.children[0].toDataURL("image/png");
            div.remove();
            const tempAnchor = $("<a>")
                .attr("href", src)
                .attr("download", filename + '.png')
                .appendTo("body");
            tempAnchor[0].click();
            tempAnchor.remove();
        }

        //Copy to Clipboard
        function copyToClipboard(id) {
            var r = document.getElementById(id);
            var r2 = document.createRange();

            if (r.select instanceof Function) {
                //copy text from HTML element (input, textarea) to the clipboard
                r.select();
                r.setSelectionRange(0, 99999);
                document.execCommand("copy");
            }
            else {
                //Copy text from HTML element (div, p, span) to the clipboard
                r2.selectNode(r);
                window.getSelection().removeAllRanges();
                window.getSelection().addRange(r2);
                document.execCommand('copy');
                window.getSelection().removeAllRanges();
            }

            UIkit.notification({
                message: '<p class="uk-text-small uk-margin-remove"><span uk-icon="icon: check"></span> Copied to clipboard</p>',
                status: 'primary',
                pos: 'bottom-right',
                timeout: 500
            });
        }

        function defaultNotification(message) {
            if (message) {
                UIkit.notification({
                    message: '<p class="uk-margin-remove uk-text-small uk-text-bold"><i class="fas fa-info-circle"></i> ' + message + '</p>',
                    status: 'primary',
                    pos: 'bottom-right',
                    timeout: 5000
                });
            }
        }

        function successNotification(message) {
            if (message) {
                UIkit.notification({
                    message: "<div class='uk-card uk-card-body' style='margin:-20px;padding:20px;font-size:16px;background-color:#007600;color:white;'> <div class='uk-grid-small' uk-grid> <div class='uk-width-auto'><span uk-icon='icon: check;'></span></div> <div class='uk-width-expand'> <span>" + message + "</span> </div> </div> </div>",
                    status: 'success',
                    pos: 'top-center',
                    timeout: 5000
                });
            }
        }

        function errorNotification(message) {
            if (message) {
                UIkit.notification({
                    message: "<div class='uk-card uk-card-body' style='margin:-20px;padding:20px;font-size:16px;background-color:#FA3E3E;color:white;'> <div class='uk-grid-small' uk-grid> <div class='uk-width-auto'><span uk-icon='icon: close;'></span></div> <div class='uk-width-expand'> <span>" + message + ".</span> </div> </div> </div>",
                    status: 'danger',
                    pos: 'top-center',
                    timeout: 10000
                });
            }
        }


        //Success/Error notification message.
        showErrorNotification = (message) => {
            if (!message) return;
            UIkit.notification.closeAll();
            UIkit.notification("<div class='uk-card uk-card-body' style='margin:-20px;padding:20px;font-size:16px;background-color:#FA3E3E;color:white;'> <div class='uk-grid-small' uk-grid> <div class='uk-width-auto'><span uk-icon='icon: close;'></span></div> <div class='uk-width-expand'> <span>" + message + ".</span> </div> </div> </div>", { pos: 'top-center', timeout: 10000 });
        };

        showSuccessNotification = (message) => {
            if (!message) return;
            UIkit.notification.closeAll();
            UIkit.notification("<div class='uk-card uk-card-body' style='margin:-20px;padding:20px;font-size:16px;background-color:#007600;color:white;'> <div class='uk-grid-small' uk-grid> <div class='uk-width-auto'><span uk-icon='icon: check;'></span></div> <div class='uk-width-expand'> <span>" + message + "</span> </div> </div> </div>", { pos: 'top-center' });
        }
    </script>
    @{
        await RenderSectionAsync("Scripts", required: false);
        await Html.RenderPartialAsync("_ValidationScriptsPartial");
    }
</body>
</html>